import java.io.*;
import java.util.*;
import java.lang.*;

public class Cache {

    HashMap fileData;
    HashMap fileSize;
    LinkedList LRUstack;
    Semaphore Lock;
    int fileDataSize;
    
    public Cache()
    {
        fileData = new HashMap();
        fileSize = new HashMap();
        LRUstack = new LinkedList();
        Lock = new Semaphore(1);
        fileDataSize=0;
    }
    
    public String getFileData(String fileName, int startIndex, int endIndex)
    {
        try
        {
            Lock.acquire();

            if (fileData.containsKey(fileName))
            {
                System.out.println("             = File already in cache");
                LRUstack.addFirst(LRUstack.remove(LRUstack.indexOf(fileName)));
                Lock.release();
            }
            else
            {
                Lock.release();
                System.out.println("             = File not in cache, loading data into main memory.");   
                BufferedReader inputFile;   
                File auxInputFile = new File(fileName);
                inputFile = new BufferedReader(new FileReader(fileName));
                char[] tempData = new char[10000];
                String temp = new String();
                temp = "";
                
                int loopInt = 1;
                
                while (loopInt>0)
                {
                    loopInt = inputFile.read(tempData,0,10000);
                    if (loopInt>0) //check bytes were read                    
                        temp+=temp.copyValueOf(tempData);
                }
                inputFile.close();
                
                fileData.put(fileName,temp);
                
                Lock.acquire();
                
                Integer tempInt = new Integer((int)auxInputFile.length());
                fileDataSize+=tempInt.intValue();
                fileSize.put(fileName, tempInt);
                LRUstack.addFirst(fileName);
                System.out.println("             = Current cache size: " + fileDataSize); 
                while (fileDataSize>100000 && LRUstack.size()>1)
                {

                    temp = (String)LRUstack.removeLast();
                    System.out.println("             = Cache full, removing " + temp); 
                    fileData.remove((String)temp);
                    fileDataSize-=((Integer)fileSize.remove((String)temp)).intValue();
                }  
                Lock.release(); 
            }
        }  
        catch (Exception e) //catch any exceptions
        {
                System.err.println(e);
        }
        
        int fileLength = ((Integer)fileSize.get(fileName)).intValue();
          
        if (fileLength>endIndex)
        {
            System.out.println("             = Returning full file data request");
            return ((String)fileData.get(fileName)).substring(startIndex,endIndex);
        }
        else
        {
            System.out.println("             = Returning patial file data request.  Reached end of file.");
            return ((String)fileData.get(fileName)).substring(startIndex,fileLength);
        }    
    }
}