import java.net.*;
import java.io.*;
import java.util.*;

class ClientResponder extends Thread {
    
    Socket socket; //local pointer to socket being processed
    Semaphore requestCountSem;
    Semaphore requestComplete;
    LinkedList responseQueue;
    Cache fileCache;
    boolean busy;
    
    ClientResponder(Cache cacheRef)
    {
        requestCountSem = new Semaphore(0);
        requestComplete = new Semaphore(0);
        responseQueue = new LinkedList();
        fileCache = cacheRef;
    }
    
    public void run() //thread's primary function
    { 
        int tempInt;
        char[] temp = new char[10000];
        responseData header;
        String response;
        String tempString = new String();
        
        System.out.println("    - clientResponder thread running");
        
        while (true)
        {
            busy=false;
            requestCountSem.acquire();
            busy=true;
            try
            {
                System.out.println("        > responderThread has been notified.  Handling request.");
                PrintWriter out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(socket.getOutputStream())), true);
                //initialize object responsible for writing data out to socket
                
                header=(responseData)responseQueue.removeFirst();
                
                response="HTTP/1.1 " + header.statusCode + " " + header.statusText; //setup header common to all responses
                
                if (header.statusCode==200) //if file was found
                {
                    response+="\nContent-Type: "+header.contentType+"\nContent-Length: "+header.contentLength+"\n";
                    System.out.println("    + Client requested " + header.resourceName);
                    out.println(response);
                    tempInt=0;
                    
                   do 
                   {
                        //System.out.println("IN LOOP ONE");
                        tempString = fileCache.getFileData(header.resourceName,tempInt,tempInt+10000);
                        tempInt+=10000;

                       out.print(tempString);
                       out.flush(); //flush buffer
                   } while (tempString.length()==10000);

                }
                else if (header.statusCode==404) //if file wasn't found
                {
                    response+="\nContent-Type: text/html\nContent-Length: 167\n\n<HTML><HEAD> <TITLE>404 Not Found</TITLE> </HEAD><BODY> <H1>Not Found</H1> The requested URL was not found on this server.<P> <HR> <ADDRESS>ChriOS/0.0.1 Server</ADDRESS> </BODY></HTML>";
                    out.println(response);
                    System.out.println("    + Client requested a file that is not present");
                }
                
                out.println("\n\n"); //send completed response header out on the socket
                
                System.out.println("        > responderThread completed request");
                
                if (this.responseQueue.size()==0)
                    requestComplete.release();
                
            } //end try
            catch (Exception e) //catch any exceptions
            {
                System.err.println(e);
            }
        } //end while
    } //end run
    
    public void newRequest(responseData header)
    {
        responseQueue.addLast((Object)header);
        this.requestCountSem.release();  
    }
    
    public void giveSocket(Socket s)
    {
        this.socket=s;         
    }
}