import java.net.*;

public class ThreadPool extends Thread {
    
    public static ClientHandler[] handlerThreads;  //handlerThreads array
    public static ClientResponder[] responderThreads;  //responderThreads array
    public static final int NUM_THREADS = 5; //defines the number of threads in the pool
    public static Semaphore activeThreadCount;
    public static Cache cacheRef;
    
    public ThreadPool() //constructor
    {
        responderThreads = new ClientResponder[NUM_THREADS];
        handlerThreads = new ClientHandler[NUM_THREADS];
        activeThreadCount = new Semaphore(NUM_THREADS);
        Cache cacheRef = new Cache();
                
        for (int i=0;i<NUM_THREADS;i++)
        {
            responderThreads[i] = new ClientResponder(cacheRef);
            handlerThreads[i] = new ClientHandler(responderThreads[i], activeThreadCount); //pass in reference to responderThread
            System.out.println("* Starting Thread " + i);
            handlerThreads[i].start();  //Exec all threads
            responderThreads[i].start();  //Exec all threads
        }
    }
    
    public static void newConnection(Socket s)
    {
        System.out.println("* New connection received");
        int i=0;
        
        activeThreadCount.acquire();
            
        while (i<NUM_THREADS) //find next available thread.
        {
            if (!handlerThreads[i].busy())
                break;
            
            System.out.println("  - Thread "+i+" is already active");
            i++;
        }
        
        System.out.println("  - Thread " + i + " is available to handle request");
        handlerThreads[i].giveSocket(s);
    }
}